#pragma once

#include "../defs.hpp"

namespace game {
namespace entity {

class Entity
{
protected:
    World *world;
    b2Body *body;
public:

    Entity(World *world) noexcept;
    virtual ~Entity() noexcept;

    virtual void Update() noexcept = 0;
    virtual void Render() noexcept = 0;

    virtual void OnCollide() {};
    virtual void OnCollide(Entity *entity) {};
};

}
}
